unit ComBasedRDataMod;

{$WARN SYMBOL_PLATFORM OFF}

interface

uses
  Windows, Messages, SysUtils, Classes, ComServ, ComObj, VCLCom, DataBkr,
  DBClient, DataSnapServer2010_TLB, StdVcl, WideStrings, DbxBlackfishSQL,
  FMTBcd, Provider, DB, SqlExpr;

type
  TUKDG = class(TRemoteDataModule, IUKDG)
    SQLConnection1: TSQLConnection;
    SQLDataSet1: TSQLDataSet;
    dspEmployees: TDataSetProvider;
    procedure dspEmployeesBeforeGetRecords(Sender: TObject;
      var OwnerData: OleVariant);
  private
    { Private declarations }
  protected
    class procedure UpdateRegistry(Register: Boolean; const ClassID, ProgID: string); override;
  public
    { Public declarations }
  end;

implementation

{$R *.DFM}

procedure TUKDG.dspEmployeesBeforeGetRecords(Sender: TObject;
  var OwnerData: OleVariant);
var
  Str: String;
begin
  Str := OwnerData;
  if Str <> '' then
  begin
    SQLDataSet1.Open;
    SQLDataSet1.First;
    while SQlDataSet1.FieldByName('EMP_NO').AsString <> Str  do
      SQlDataSet1.Next;
    SQlDataSet1.Next; // go to the next one
  end
end;

class procedure TUKDG.UpdateRegistry(Register: Boolean; const ClassID, ProgID: string);
begin
  if Register then
  begin
    inherited UpdateRegistry(Register, ClassID, ProgID);
    EnableSocketTransport(ClassID);
    EnableWebTransport(ClassID);
  end else
  begin
    DisableSocketTransport(ClassID);
    DisableWebTransport(ClassID);
    inherited UpdateRegistry(Register, ClassID, ProgID);
  end;
end;

initialization
  TComponentFactory.Create(ComServer, TUKDG,
    Class_UKDG, ciMultiInstance, tmApartment);
end.
