unit Logging;
interface
uses
  SysUtils;

procedure LogError(const Str: String);

procedure EnterMethod(const Str: String);
procedure ExitMethod(const Str: String);


implementation
uses
  Windows;

var
  indent: Integer;

procedure LogError(const Str: String);
var
  f: TextFile;
begin {$I-}
  Assign(f,ChangeFileExt(ParamStr(0),'.log'));
  Append(f);
  if IOResult <> 0 then
  begin
    Rewrite(f);
    writeln(f,'*** Start: ' + DateTimeToStr(Now) + ' ***');
  end;
  if Str <> '' then
    if indent > 0 then write(f,FormatDateTime('hh:nn:ss.zzz', Time):8, ' ':indent);
  writeln(f,Str);
  Close(f);
  if IOResult <> 0 then
end;

procedure EnterMethod(const Str: String);
begin
  LogError('ENTER: ' + Str);
  Inc(indent);
end;

procedure ExitMethod(const Str: String);
begin
  Dec(indent);
  LogError('EXIT:= ' + Str);
end;


initialization
  indent := 1;
end.
